<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSEntryDoor ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSEntryDoor extends AbstractStructArrayBase
{
    /**
     * The WSEntryDoor
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSEntryDoor[]
     */
    public $WSEntryDoor;
    /**
     * Constructor method for ArrayOfWSEntryDoor
     * @uses ArrayOfWSEntryDoor::setWSEntryDoor()
     * @param \StructType\WSEntryDoor[] $wSEntryDoor
     */
    public function __construct(array $wSEntryDoor = array())
    {
        $this
            ->setWSEntryDoor($wSEntryDoor);
    }
    /**
     * Get WSEntryDoor value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSEntryDoor[]|null
     */
    public function getWSEntryDoor()
    {
        return isset($this->WSEntryDoor) ? $this->WSEntryDoor : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSEntryDoor method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSEntryDoor method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSEntryDoorForArrayConstraintsFromSetWSEntryDoor(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSEntryDoorWSEntryDoorItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSEntryDoorWSEntryDoorItem instanceof \StructType\WSEntryDoor) {
                $invalidValues[] = is_object($arrayOfWSEntryDoorWSEntryDoorItem) ? get_class($arrayOfWSEntryDoorWSEntryDoorItem) : sprintf('%s(%s)', gettype($arrayOfWSEntryDoorWSEntryDoorItem), var_export($arrayOfWSEntryDoorWSEntryDoorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSEntryDoor property can only contain items of type \StructType\WSEntryDoor, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSEntryDoor value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryDoor[] $wSEntryDoor
     * @return \ArrayType\ArrayOfWSEntryDoor
     */
    public function setWSEntryDoor(array $wSEntryDoor = array())
    {
        // validation for constraint: array
        if ('' !== ($wSEntryDoorArrayErrorMessage = self::validateWSEntryDoorForArrayConstraintsFromSetWSEntryDoor($wSEntryDoor))) {
            throw new \InvalidArgumentException($wSEntryDoorArrayErrorMessage, __LINE__);
        }
        if (is_null($wSEntryDoor) || (is_array($wSEntryDoor) && empty($wSEntryDoor))) {
            unset($this->WSEntryDoor);
        } else {
            $this->WSEntryDoor = $wSEntryDoor;
        }
        return $this;
    }
    /**
     * Add item to WSEntryDoor value
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryDoor $item
     * @return \ArrayType\ArrayOfWSEntryDoor
     */
    public function addToWSEntryDoor(\StructType\WSEntryDoor $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSEntryDoor) {
            throw new \InvalidArgumentException(sprintf('The WSEntryDoor property can only contain items of type \StructType\WSEntryDoor, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSEntryDoor[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSEntryDoor|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSEntryDoor|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSEntryDoor|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSEntryDoor|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSEntryDoor|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSEntryDoor
     */
    public function getAttributeName()
    {
        return 'WSEntryDoor';
    }
}
